<?php

namespace Ems\Generators;

use PhpOffice\PhpSpreadsheet\Writer\Xlsx;
use PhpOffice\PhpSpreadsheet\Spreadsheet;

class XlsGenerator
{
    /**
     * Gera um arquivo XLS a partir de um objeto Spreadsheet.
     *
     * @param Spreadsheet $spreadsheet O objeto Spreadsheet.
     * @return string O conteúdo binário do arquivo XLS.
     */
    public static function generateFromSpreadsheet(Spreadsheet $spreadsheet): string
    {
        $writer = new Xlsx($spreadsheet);

        $tempMemory = fopen('php://memory', 'w+'); // Cria um buffer de memória
        $writer->save($tempMemory); // Salva o arquivo no buffer
        rewind($tempMemory); // Reposiciona o ponteiro para o início do buffer

        $blob = stream_get_contents($tempMemory); // Lê o conteúdo do buffer
        fclose($tempMemory); // Fecha o buffer

        return $blob;
    }
}
